#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file EFNS.cc
 * @brief 9٥ȥ u ιԤ
 * @param u 9٥ȥ u
 * @param xi 9٥ȥ \xi_{alpha}
 * @param V_0 9x9 \V_0
 * @param epsilon «ȽѤο
 * @return 9٥ȥ
 * @author Kento YAMADA
 * @dage 2008.11.17
 */
VecC EFNS( VecC &u, vector< VecC > xi, vector< Mat > V_0, double epsilon ) {

  Mat M( 9, 9 ), L( 9, 9 ) ;  //!< 9x9 \mM  \mL
  VecC u_dag( 9 ) ;           //!< 9 \vu^\dag
  Mat P_u( 9, 9 ) ;           //!< 9x9 \mP_{\vu^\dag}
  Mat X( 9, 9 ), Y( 9, 9 ) ;  //!< 9x9 \mX  \mL
  Mat EV( 9, 9 ), U( 9, 9) ;  //!< ͭ٥ȥǼ
  VecC V( 9 ) ;               //!< ͭͤ򾮤Ǽ
  /* Ǿͭͤбñ̥٥ȥ \vv_1 
   * 2ܤ˾ͭͤбñ̥٥ȥ\vv_2 */
  VecC v_1( 9 ), v_2( 9 ) ;
  VecC u_hat( 9 ), u_prime( 9 ) ;  //!< 9٥ȥ \hat{\vu}  \prime{\vu}
  double err = 0.0 ;  //!< «Ƚθ


  do {
    /* STEP 01 */
    /* 9x9  \mM  \mL  */
    M.clear( 0.0 ) ;
    L.clear( 0.0 ) ;
    for( unsigned int i = 0; i < xi.size(); i++ ) {
      M += (xi[i] * ~xi[i]) / (u, V_0[i]*u) ;
      L += (((u,xi[i])*(u,xi[i])) * V_0[i]) / ((u, V_0[i]*u)*(u, V_0[i]*u)) ;
    }

    
    /* STEP 02 */
    /* 9 \vu^\dag */
    u_dag[0] = (u[4]*u[8])-(u[7]*u[5]) ;
    u_dag[1] = (u[5]*u[6])-(u[8]*u[3]) ;
    u_dag[2] = (u[3]*u[7])-(u[6]*u[4]) ;
    u_dag[3] = (u[7]*u[2])-(u[1]*u[8]) ;
    u_dag[4] = (u[8]*u[0])-(u[2]*u[6]) ;
    u_dag[5] = (u[6]*u[1])-(u[0]*u[7]) ;
    u_dag[6] = (u[1]*u[5])-(u[4]*u[2]) ;
    u_dag[7] = (u[2]*u[3])-(u[5]*u[0]) ;
    u_dag[8] = (u[0]*u[4])-(u[3]*u[1]) ;
    u_dag = normalize( u_dag ) ;

    /* 9x9 \mP_{\vu^\dag}  */
    P_u = id_matrix( 9 ) - (u_dag * ~u_dag) ;
 
 
    /* STEP 03 */
    /* 9x9 \mX  \mY  */
    X = M - L ;
    Y = P_u * X * P_u ;



    /* STEP 04 */
    /*  \mY κǾͭ \vv_1 
     * 2ܤ˾ͭͤб9ñ̸ͭ٥ȥ \vv_2  */
    eigen_vector( Y, EV, V ) ;

    v_1 = EV( 8 ) ;
    v_2 = EV( 7 ) ;


    /* STEP 05 */
    /* 9٥ȥ \hat{\vu}  */
    u_hat = ( (u, v_1) * v_1 ) + ( ( u, v_2 ) * v_2 ) ;
    
    
    /* STEP 06 */
    /* 9٥ȥ \prime{\vu}  */
    u_prime = normalize( P_u * u_hat ) ;


    /* STEP 07 */
    /* \prime{\vu}  \vu ѤƼ«ȽԤ */
    err = norm( u_prime - u ) ;

    /* \vu ͤ򹹿 */
    u = normalize( u + u_prime) ;

  } while( err >= epsilon ) ;

  return u_prime ;
}
