#include "newCalcFundamental.h"
#include "solve3DEquation.h"

using namespace std;

/**
 * @file calcFixFocus.cc
 * @brief ǤʤξΥη׻
 * @param F ù
 * @param f1, f2 ׻ΥǼ
 * @author Kento YAMADA
 * @date 2008.11.19
 */
void calcFixFocus( const Mat F, double &f1, double &f2 ) {

  cout << "# Υ" << endl ;
  double x ;  //!< Υȴùμβ
  double Kx1, Kx3 ;  //!< Υ˴ؤؿ K 
  double a1, a2, a3, a4, a5 ;
  double kFk, sqFk, sqFtk ;  //!< 3򤯤ݤȽԤѿ
  double condition ;  //!< 3򤯤ݤȽԤѿ
  VecC k( 0, 0, 1 ) ;  //!< ٥ȥ

  
  /* STEP 01 */
  /* a_1 a_2 a_3 a_4 ׻ */
  calcKparameter( F, a1, a2, a3, a4, a5 ) ;

  cout << "# parameter a1 = " << a1 << endl ;
  cout << "# parameter a2 = " << a2 << endl ;
  cout << "# parameter a3 = " << a3 << endl ;
  cout << "# parameter a4 = " << a4 << endl ;
  cout << "# parameter a5 = " << a5 << endl ;



  /* STEP 02 */
  /* x η׻ˡˡȽꤹ(3򤯤ݤ) */
  kFk = ( k, F * k ) ;
  sqFk = sqnorm( F * k ) ;
  sqFtk = sqnorm( ~F * k ) ;
  condition = 0.1 * ( (sqFk > sqFtk ) ? sqFtk : sqFk ) / f ;
  
  cout << "# |kFk| : " << kFk << endl ;
  cout << "# 0.1min(||Fk||,||Ftk||)/f0 : " << condition << endl ;


  /* STEP 03 */
  /* x ͤ׻ */
  if( fabs(kFk) < condition ) {
    cout << "# ̾׻" << endl ;
    x = -( a4 / (2.0*a3) ) ;
  } else {
    /* 3 */
    cout << "# 3" << endl ;
    double x1, x2, x3 ;

    /* ΤθѤơ3 β */
    solve3DEquation( 4.0*a1, 3.0*a2, 2.0*a3, a4, x1, x2, x3 ) ;
    cout << "# x1 : " << x1 << endl ;
    cout << "# x2 : " << x2 << endl ;
    cout << "# x3 : " << x3 << endl ;

    if( x2 == 0.0 && x3 == 0.0 ) {
      /* ͣμ¿ľ */
      x = x1 ;
    } else {
      /* 3 Ĥμ¿ľ */
      Kx1 = a1*x1*x1*x1*x1 + a2*x1*x1*x1 + a3*x1*x1 + a4*x1 + a5 ;
      Kx3 = a1*x3*x3*x3*x3 + a2*x3*x3*x3 + a3*x3*x3 + a4*x3 + a5 ;

      cout << "# K(xi 1) : " << Kx1 << endl ;
      cout << "# K(xi 3) : " << Kx3 << endl ;
      if( 0.0 <= Kx3 && Kx3 < Kx1 ) {  
        x = x3 ;
      } else if( x3 <= -1.0 || Kx3 < 0.0 || Kx1 < Kx3 ) {
        x = x1 ;
      } else {
        x = -1.0 ;
      }
    }
  }

  cout << "# final x : " << x << endl ;

  /* STEP 04 */
  if( x <= -1 ) {
    cout << "# ERROR : x <= -1" << endl ;
    cout << "# ǥեȾΥΥȤ" << endl ;
    f1 = f2 = f ;
  } else {
    f1 = f2 = f / sqrt( 1 + x ) ;
  }
}
