#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file calcK.cc
 * @brief Υ׻˻Ѥ K(eta, xi) 
 * @param F ù
 * @author Kento YAMADA
 * @date 2009.7.23
 */
void calcK( const Mat F ) {

  VecC k( 0, 0, 1 ) ;  //!< ٥ȥ
  double K ;

  /* Ƽѥ᡼׻ */
  double kFk    = (k,F*k) ;
  double sqkFk  = kFk * kFk ;
  double sqFk   = sqnorm(F*k) ;
  double sqFtk  = sqnorm(~F*k) ;
  double sqFtFk = sqnorm(~F*F*k) ;
  double sqFFtk = sqnorm(F*~F*k) ;

  for( double xi = -10.0; xi <= 10.0; xi += 1.0 ) {
    for( double eta = -10.0; eta <= 10.0; eta += 1.0 ) {
      K = (sqkFk * sqkFk * xi * xi * eta * eta)
        + (2.0 * sqkFk * sqFtk * sqFtk * xi * xi * eta)
        + (2.0 * sqkFk * sqFk * sqFk * xi * eta * eta)
        + (sqFtk * sqFtk * sqFtk * sqFtk * xi * xi)
        + (sqFk * sqFk * sqFk * sqFk * eta * eta)
        + (4.0 * kFk * (k, F * ~F * F * k) * xi * eta)
        + (2.0 * sqFFtk * sqFFtk * xi)
        + (2.0 * sqFtFk * sqFtFk * eta) ;
        + ((F*~F).sqnorm() * (F* ~F).sqnorm())
        - (0.5 * (sqkFk * xi * eta) + (sqFtk * sqFtk * xi) + (sqFk * sqFk * eta) + ((F).sqnorm() * (F).sqnorm()) * (sqkFk * xi * eta) + (sqFtk * sqFtk * xi) + (sqFk * sqFk * eta) + ((F).sqnorm() * (F).sqnorm())) ;
      cerr << xi << " " << eta << " " << K << endl ; 
    }
  }
}
