#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file calcMotion.cc
 * @brief ưѥ᡼
 * @param x1 x2 ħ
 * @param F ù
 * @param f1 f2 Υ
 * @param t ᤿¿ʤǼ
 * @param R ᤿ž󤬳Ǽ
 * @author Kento YAMADA
 * @date 2008.11.21
 */
void calcMotion( vector< VecC > &x1, vector< VecC > &x2,
                 const Mat F, const double f1, const double f2,
                 VecC &t, Mat &R ) {

  Mat E( 3, 3 ) ;  //!< ܹ \mE
  Mat V( 3, 3 ), U( 3, 3 ) ;  //!< ͭʬѤι
  VecC S( 3 ) ;  //!< ͭʬѤΥ٥ȥ
  //!< ħȤ3٥ȥˤ
  vector< VecC > x1_hat( x1.size() ), x2_hat( x2.size() ) ;


  /* STEP 01 */
  /* ܹ \mE  */
  E = diag33( 1, 1, f/f1 ) * F * diag33( 1, 1, f/f2 ) ;


  /* STEP 02 */
  /* 3x3 \mE\mEt κǾͭͤФ3ñ̸ͭ٥ȥ */
  t = min_eigen_vector( E * ~E ) ;
 

  /* STEP 03 */
  /* ħȤ3٥ȥɽ */
  for( unsigned int i = 0; i < x1_hat.size(); i++ ) {
    x1_hat[i][0] = x1[i][0] / f1 ;
    x1_hat[i][1] = x1[i][1] / f1 ;
    x2_hat[i][0] = x2[i][0] / f2 ;
    x2_hat[i][1] = x2[i][1] / f2 ;
    x1_hat[i][2] = x2_hat[i][2] = 1.0 ;
  }


  /* STEP 04 */
  /* ¿ \vt ѹ뤫ݤȽԤ */
  double scalar = 0.0 ;
  for( unsigned int i = 0; i < x1_hat.size(); i++ ) {
    scalar += ( (t % x1_hat[i]) , (E*x2_hat[i]) ) ;
  }
  /* 黰Ѥ¤ʤ¿ \vt ȿž */
  if( scalar < 0 ) {
    t *= -1 ;
  }


  /* STEP 05 */
  /*  -\vt x \mE ðʬ򤹤 */
  SVD( -t % E, V, S, U ) ;


  /* STEP 06 */
  /* ž \mR  */
  R = V * diag33( 1, 1, det(V * ~U)) * ~U ;
}
