/**
 * @file
 * @brief Υ饹
 * @author ()
 */

#ifndef KANAZAWA_LAB_MAT_H_INCLUDED
#define KANAZAWA_LAB_MAT_H_INCLUDED

#include "nr.h"
#include "Vec.h"

#if __GNUC__ >= 3
# include <new>         // std::bad_alloc ꤲʤ褦ˤ뤿
# if defined DEBUG
#  include <limits>     // std::numeric_limits<double>::quiet_NaN()
# endif
#endif

/// 漼饤֥ζ̾
namespace Lab
{
    /// Υ饹
    class Mat
    {
        VecR* mat_;     ///< ǥΤιԥ٥ȥ
        int   rows_;    ///< Կ
        int   cols_;    ///< 

        /**
         * ιԿ򤽤줾 @a row  @a col ꤷ󤬻Ѥ
         * ݤ롥
         * @brief ΰݤ롥
         * @param [in] row Կ
         * @param [in] col 
         */
        void allocate(int row, int col);

    public:
        /**
         * @a row  @a col ι륳󥹥ȥ饯
         * @brief 󥹥ȥ饯
         * @param [in] row Կ
         * @param [in] col 
         */
        explicit Mat(int row = DEFAULT_SIZE, int col = DEFAULT_SIZE);

        /**
         * Ǥͤ @a a, @a b, @a c, @a d, @a e, @a f, @a g, @a h, @a i
         *  3 x 3 륳󥹥ȥ饯
         * @brief 󥹥ȥ饯
         * @param [in] a (1,1)Ǥ
         * @param [in] b (1,2)Ǥ
         * @param [in] c (1,3)Ǥ
         * @param [in] d (2,1)Ǥ
         * @param [in] e (2,2)Ǥ
         * @param [in] f (2,3)Ǥ
         * @param [in] g (3,1)Ǥ
         * @param [in] h (3,2)Ǥ
         * @param [in] i (3,3)Ǥ
         */
        Mat(double a, double b, double c,
            double d, double e, double f,
            double g, double h, double i);

        /**
         * @a row  @a col ι륳󥹥ȥ饯
         * Ǥͤ @a d Ǽ줿ͤѤ롥
         * @brief 󥹥ȥ饯
         * @param [in] d Ǥͤä
         * @param [in] row Կ
         * @param [in] col 
         */
        explicit Mat(const double* d,
                     int row = DEFAULT_SIZE, int col = DEFAULT_SIZE);

        /**
         * @a c1, @a c2, @a c3  3 ܤ٥ȥ뤫륳󥹥ȥ饯
         * 
         * @brief 󥹥ȥ饯
         * @param [in] c1 ٥ȥ1
         * @param [in] c2 ٥ȥ2
         * @param [in] c3 ٥ȥ3
         */
        Mat(const VecC& c1, const VecC& c2, const VecC& c3);

        /**
         * ԡ󥹥ȥ饯
         * @brief ԡ󥹥ȥ饯
         * @param [in] M ԡ
         */
        Mat(const Mat& M);

        /**
         * ǥȥ饯
         * @brief ǥȥ饯
         */
        ~Mat();

        /**
         * ιԿ򤽤줾 @a row  @a col ꤹ롥
         * @brief Υѹ
         * @param [in] row Կ
         * @param [in] col 
         */
        void realloc(int row, int col)
        {
            rows_ = row;
            cols_ = col;
            if (mat_ != NULL)
                delete [] mat_;

#if __GNUC__ < 3 || defined(USE_EXCEPTION)
            // new ϥݼԻ std::bad_alloc 㳰Ф
            mat_ = new VecR[row];
#else
            // new ϥݼԻ 0 ֤
            mat_ = new(std::nothrow) VecR[row];
#endif
            if (mat_ == NULL)
            {
#if __GNUC__ < 3
                cerr <<
#else
                std::cerr <<
#endif
                    "### Memory Alloc Error (Mat.realloc) ###\n";
                ::abort();
            }

            for (int i = 0; i < row; i++)
            {
                mat_[i].renew(col);
#if __GNUC__ >= 3 && defined DEBUG
                // ˺ˤץȯŤ餤ư򤱤뤿ˡ
                // ͤ NaN (Not a number) ǽƤ
                // (Ψθǡץץåܥ
                // DEBUG ƤΤߡȤ)
                for (int j = 0; j < col; j++)
                    mat_[i].vec_[j] = std::numeric_limits<double>::quiet_NaN();
#endif
            }
        }

        /**
         * @a i ܤιԥ٥ȥФ
         * @brief ԥ٥ȥФ
         * @param [in] i Ф
         * @return Ф줿ԥ٥ȥ
         */
        VecR& operator [] (int i) const
        {
            assert((i >= 0) && (i < rows_));
            return mat_[i];
        }

        /**
         * @a j ܤιԥ٥ȥФ
         * @brief ٥ȥФ
         * @param [in] j Ф
         * @return Ф줿٥ȥ
         */
        VecC operator () (int j) const
        {
            VecC C(rows_);
            assert((j >= 0) && (j < cols_));
            for (int i = 0; i < rows_; i++)
                C[i] = mat_[i].vec_[j];
            return C;
        }

        /**
         * 黻ҡ
         * @brief 黻
         * @param [in] M 
         * @return 줿
         */
        Mat& operator = (const Mat& M)
        {
            assert(M.rows_ == rows_ && M.cols_ == cols_);
            if (&M == this) return *this;
            for (int i = 0; i < rows_; i++)
                for (int j = 0; j < cols_; j++)
                    mat_[i].vec_[j] = M[i].vec_[j];
            return *this;
        }

        /**
         * Ƥ򥹥ȥ꡼ @a s ؽ @a format ƽϤ롥
         * @brief Ϥ롥
         * @param [in] s 襹ȥ꡼
         * @param [in] format 񼰻ʸ
         */
#if __GNUC__ < 3
        void print(ostream& s, const char* format) const;
#else
        void print(std::ostream& s, const char* format) const;
#endif

        /**
         * ߤι˹ @a M û롥
         * @brief û黻
         * @param [in] M 
         * @return 黻
         */
        Mat& operator += (const Mat& M);

        /**
         * ߤι󤫤 @a M 򸺻롥
         * @brief 黻
         * @param [in] M 
         * @return 黻
         */
        Mat& operator -= (const Mat& M);

        /**
         * ߤιȹ @a M Ѥ롥
         * @brief 軻黻
         * @param [in] M 
         * @return 黻
         */
        Mat& operator *= (const Mat& M);

        /**
         * ߤι˥ @a a 褸롥
         * @brief 軻黻
         * @param [in] a 
         * @return 黻
         */
        Mat& operator *= (const double a);

        /**
         * ߤι򥹥 @a a ǽ롥
         * @brief 黻
         * @param [in] a 
         * @return 黻
         */
        Mat& operator /= (const double a);

        /**
         * Υե٥˥Υ׻롥
         * @brief ե٥˥Υ롥
         * @return ե٥˥Υ
         */
        double norm() const;

        /**
         * 2ե٥˥Υ׻롥
         * @brief 2ե٥˥Υ롥
         * @return 2ե٥˥Υ
         */
        double sqnorm() const;

        /**
         * @brief 2ե٥˥Υ롥
         * @note "sqrt (= square root)" դߤС"sqrnorm" ǤϤʤ
         *       "sqnorm" ؿ̾ȤŬڤȻפ롥
         * @sa Mat::sqnorm()
         */
        DEPRECATED double sqrnorm() const { return sqnorm(); }

        /**
         * ιԿ롥
         * @brief Կ롥
         * @return Կ
         */
        int row() const { return rows_; }

        /**
         * 롥
         * @brief 롥
         * @return 
         */
        int col() const { return cols_; }

        /**
         * Ǥ @a data ǽ롥
         * @brief Ǥ롥
         * @param [in] data 
         */
        void clear(double data = 0.0);

        /**
         *  @a n ܤ @a V ꤹ롥
         * @brief ͤꤹ롥
         * @param [in] n ꤹ
         * @param [in] V ꤹ٥ȥ
         */
        void setcvec(int n, VecC& V);

        /**
         * ȥ꡼ @a s  @a M ɤ߹ࡥ
         * @brief ȥ꡼फɤ߹ࡥ
         * @param [in,out] s ϥȥ꡼
         * @param [out] M 
         */
#if __GNUC__ < 3
        friend istream& operator >> (istream& s, Mat& M);
#else
        friend std::istream& operator >> (std::istream& s, Mat& M);
#endif

        /**
         *  @a M 򥹥ȥ꡼ @a s ˽Ϥ롥
         * @brief 򥹥ȥ꡼˽Ϥ
         * @param [in,out] s ϥȥ꡼
         * @param [in] M 
         */
#if __GNUC__ < 3
        friend ostream& operator << (ostream& s, const Mat& M);
#else
        friend std::ostream& operator << (std::ostream& s, const Mat& M);
#endif

        /**
         *  @a M γǤ򥹥 @a a ǳä롥
         * @brief 򥹥ǳ롥
         * @param [in] M 
         * @param [in] a 
         * @return 黻
         */
        friend Mat operator / (const Mat& M, double a);

        /**
         *  @a M1  @a M2 Ѥ롥
         * @brief ƱΤѤ롥
         * @param [in] M1 
         * @param [in] M2 
         * @return 黻
         */
        friend Mat operator * (const Mat& M1, const Mat& M2);

        /**
         *  @a M γǤ򥹥 @a a ܤ롥
         * @brief γǤ򥹥ܤ롥
         * @param [in] M 
         * @param [in] a 
         * @return 黻
         */
        friend Mat operator * (const Mat& M, double a);

        /**
         *  @a M γǤ򥹥 @a a ܤ롥
         * @brief γǤ򥹥ܤ롥
         * @param [in] a 
         * @param [in] M 
         * @return 黻
         */
        friend Mat operator * (double a, const Mat& M);

        /**
         *  @a M1 ˹ @a M2 ä롥
         * @brief ƱΤ¤롥
         * @param [in] M1 
         * @param [in] M2 
         * @return 黻
         */
        friend Mat operator + (const Mat& M1, const Mat& M2);

        /**
         *  @a M1  @a M2 κä롥
         * @brief ƱΤκ롥
         * @param [in] M1 
         * @param [in] M2 
         * @return 黻
         */
        friend Mat operator - (const Mat& M1, const Mat& M2);

        /**
         *  @a M γǤȿž롥
         * @brief γǤȿž롥
         * @param [in] M 
         * @return Ǥȿž
         */
        friend Mat operator - (const Mat& M);

        /**
         *  @a M ž֤롥
         * @brief ž֤롥
         * @param [in] M 
         * @return @a M ž
         */
        friend Mat operator ~ (const Mat& M);

        /**
         *  @a M1  @a M2 ž֤ѤΥȥ졼롥
         * @brief ѱ黻Ԥ
         * @param [in] M1 
         * @param [in] M2 
         * @return @a M1  @a M2 ž֤ѤΥȥ졼
         */
        friend double operator , (const Mat& M1, const Mat& M2);
    };

    /**
     *  @a M1  @a M2 Ĵ٤롥
     * @brief ӱ黻
     * @param [in] M1 
     * @param [in] M2 
     * @retval true @a M1  @a M2 
     * @retval false @a M1  @a M2 ʤ
     */
    bool operator == (const Mat& M1, const Mat& M2);

    /**
     *  @a M1  @a M2 ʤĴ٤롥
     * @brief ӱ黻
     * @param [in] M1 
     * @param [in] M2 
     * @retval true @a M1  @a M2 ʤ
     * @retval false @a M1  @a M2 
     */
    bool operator != (const Mat& M1, const Mat& M2);

    /**
     * ԥ٥ȥ @a RV ȹ @a M Ѥ롥
     * @brief ԥ٥ȥȹѤ롥
     * @param [in] RV ԥ٥ȥ
     * @param [in] M 
     * @return 黻(ԥ٥ȥ)
     */
    VecR operator * (const VecR& RV, const Mat& M);

    /**
     *  @a M ٥ȥ @a CV Ѥ롥
     * @brief ٥ȥѤ롥
     * @param [in] M 
     * @param [in] CV ٥ȥ
     * @return 黻(٥ȥ)
     */
    VecC operator * (const Mat& M, const VecC& CV);

    /**
     * ٥ȥ @a CV ȹԥ٥ȥ @a RV Ѥ롥
     * @brief ٥ȥȹԥ٥ȥѤ롥
     * @param [in] CV ٥ȥ
     * @param [in] RV ԥ٥ȥ
     * @return 黻()
     */
    Mat operator * (const VecC& CV, const VecR& RV);

    /**
     * § @a M εչ롥
     * @brief չ롥
     * @param [in] M 
     * @return @a M εչ
     */
    Mat inverse(const Mat& M);

    /**
     * @a M κǾ跿ΰ̵չ롥
     * @brief ̵չ롥
     * @param [in] M 
     * @return @a M ΰ̵չ
     */
    Mat gen_inv(const Mat& M);

    /**
     * @a M Υ @a r δݤ̵չ롥
     * @brief ݤ̵չ롥
     * @param [in] M 
     * @param [in] r 
     * @return @a M δݤ̵չ
     */
    Mat trc_gen_inv(const Mat& M, int r);

    /**
     * @a M  DET_EPS ̤Ǥ 0 ִ롥
     * @brief Ǥ 0 ˴ݤ롥
     * @param [in] M 
     * @return ִι
     */
    Mat ignore_EPS(const Mat& M);

    /**
     * @a M ι󼰤롥
     * @brief 󼰤롥
     * @param [in] M 
     * @return @a M ι
     */
    double det(const Mat& M);

    /**
     * 3 x 3  @a M ι󼰤롥
     * @brief 3 x 3 ι󼰤롥
     * @param [in] M 3 x 3 
     * @return @a M ι
     */
    double det33(const Mat& M);

    /**
     * 3 x 3  @a M0 ι󼰤롥
     * ΤȤ DET_EPS ̤ͤ 0 Ȥư
     * @brief 3 x 3 ι󼰤롥
     * @param [in] M0 3 x 3 
     * @return @a M0 ι
     */
    double det33EPS(const Mat& M0);

    /**
     * 2 x 2  @a M ι󼰤롥
     * @brief 2 x 2 ι󼰤롥
     * @param [in] M 2 x 2 
     * @return @a M ι
     */
    inline double det22(const Mat& M) {
        assert(M.row() == 2 && M.col() == 2);
        return M[0][0] * M[1][1] - M[0][1] * M[1][0];
    }

    /**
     * 2 x 2  @a M0 ι󼰤롥
     * ΤȤ DET_EPS ̤ͤ 0 Ȥư
     * @brief 2 x 2 ι󼰤롥
     * @param [in] M0 2 x 2 
     * @return @a M0 ι
     */
    inline double det22EPS(const Mat& M0) {
        return det22(ignore_EPS(M0));
    }

    /**
     * @a M Υȥ졼롥
     * @brief ȥ졼롥
     * @param [in] M 
     * @return @a M Υȥ졼
     */
    double trace(const Mat& M);

    /**
     *  @a M θͭͤȸͭ٥ȥ롥
     * ͭͤ @a V ˺Ǿͭͤ˳Ǽ졤
     * бͭ٥ȥ٥ȥ¤٤Ȥ @a EV ˳Ǽ롥
     * @brief ͭͤȸͭ٥ȥ롥
     * @param [in] M 
     * @param [out] EV ͭ٥ȥγǼ
     * @param [out] V ͭͤγǼ
     */
    void eigen_vector(const Mat& M, Mat& EV, VecC& V);

    /**
     *  @a M κǾͭͤбͭ٥ȥ롥
     * @brief Ǿͭͤбͭ٥ȥ롥
     * @param [in] M 
     * @return Ǿͭͤбͭ٥ȥ
     */
    VecC min_eigen_vector(const Mat& M);

    /**
     *  @a M κǾͭͤȤбͭ٥ȥ롥
     * @brief ǾͭͤȤбͭ٥ȥ롥
     * @param [in] M 
     * @param [out] l ǾͭͤγǼ
     * @return Ǿͭͤбͭ٥ȥ
     */
    VecC min_eigen_vector2(const Mat& M, double* l);

    /**
     *  @a M 򥳥쥹 Banachiewicz ˡʬ򤷡ѹ롥
     * @brief 򥳥쥹ʬ򤹤롥
     * @param [in] M 
     * @return ž֤򱦤褸 @a M Ȥʤ褦ʲѹ
     * @note @a M оιǤʤФʤʤ
     */
    Mat CholeskyDecomp(const Mat& M);

    /**
     *  @a M ðʬ򤷡̤ľ @a V, ðͤ򾮤¤٤
     * ٥ȥ @a S, ľ @a U ˳Ǽ롥
     * @brief ðʬ򤹤롥
     * @param [in] M 
     * @param [out] V ľ٥ȥ٥ȥˤĹ
     * @param [out] S ðͤ򾮤¤٤٥ȥ
     * @param [out] U ľ٥ȥ٥ȥˤĹ
     * @note @a M  n  m  ιǤС@a V  n  m ι, @a S 
     * m ٥ȥ, @a U  m  m ιǤʤФʤʤ
     */
    void SVD(const Mat& M, Mat& V, VecC& S, Mat& U);

    /**
     * ϢΩ 1  @a A * x = @a B β롥
     * @brief ϢΩ 1 β롥
     * @param [in] A 
     * @param [in] B ϢΩα
     * @return ϢΩβ
     * @note @a A §ǤʤФʤʤ
     */
    VecC SLE(const Mat& A, const VecC& B);

    /**
     * @a n ñ̹롥
     * @brief ñ̹롥
     * @param [in] n 
     * @return ñ̹
     */
    Mat id_matrix(int n);

    /**
     *  @a A   @a B γѤ롥
     * @brief ƱΤγѤ롥
     * @param [in] A 
     * @param [in] B 
     * @return 黻
     */
    Mat ext_product(const Mat& A, const Mat& B);

    /**
     * ٥ȥ @a v ȹ @a M γѤ롥
     * @brief ٥ȥȹγѤ롥
     * @param [in] v 
     * @param [in] M 
     * @return 黻
     */
    Mat operator % (const VecC& v, const Mat& M);

    /**
     *  @a M ٥ȥ @a V γѤ롥
     * @brief ٥ȥȹγѤ롥
     * @param [in] M 
     * @param [in] V 
     * @return 黻
     */
    Mat operator % (const Mat& M, const VecC& V);

    /**
     *  @a M оβԤ
     * @brief оβԤ
     * @param [in] M 
     * @return оι
     */
    Mat sym(const Mat& M);

    /**
     * 3 x 3  @a M  3 ܤ٥ȥ @a u1, @a u2, @a u3 ʬ롥
     * @brief 3 x 3 ٥ȥʬ롥
     * @param [in] M 
     * @param [out] u1 1ܤǤγǼ
     * @param [out] u2 2ܤǤγǼ
     * @param [out] u3 3ܤǤγǼ
     */
    void col3(const Mat& M, VecC& u1, VecC& u2, VecC& u3);

    /**
     * 3 x 3  @a M ;ҹ롥
     * @brief 3 x 3 ;ҹ롥
     * @param [in] M 
     * @return ;ҹ
     */
    Mat cofactor33(const Mat& M);

    /**
     *  @a M Υե٥˥Υब 1 ˤʤ褦롥
     * @brief 롥
     * @param [in] M 
     * @return 
     */
    Mat normalize(const Mat& M);

    /**
     * гǤ٥ȥ @a V ǤǤ褦гѹ롥
     * @brief гѹ롥
     * @param [in] V ٥ȥ
     * @return гѹ
     */
    Mat diag(const Vec& V);

    /**
     * гǤ @a a, @a b, @a c Ǥ 3 x 3 гѹ롥
     * @brief 3 x 3 гѹ롥
     * @param [in] a (1,1)
     * @param [in] b (2,2)
     * @param [in] c (3,3)
     * @return гѹ
     */
    Mat diag33(double a, double b, double c);

    /**
     *  @a M гǤȴФгѹ롥
     * @brief гѹ롥
     * @param [in] M 
     * @return гѹ
     */
    Mat diag(const Mat& M);
}

#endif  // KANAZAWA_LAB_MAT_H_INCLUDED

